Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateChargeTransferProton.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateChargeTransferProton.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateChargeTransferProton.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FinalStateChargeTransferProton.cc,v 1.2 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticBrennerZaider.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticBrennerZaider.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticBrennerZaider.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateElasticBrennerZaider.cc,v 1.11 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "G4FinalStateElasticBrennerZaider.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticChampion.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticChampion.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticChampion.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateElasticChampion.cc,v 1.10 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // -------------------------------------------------------------------
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticScreenedRutherford.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticScreenedRutherford.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticScreenedRutherford.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateElasticScreenedRutherford.cc,v 1.7 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "G4FinalStateElasticScreenedRutherford.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationBorn.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationBorn.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationBorn.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateExcitationBorn.cc,v 1.6 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "G4FinalStateExcitationBorn.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationEmfietzoglou.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationEmfietzoglou.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationEmfietzoglou.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateExcitationEmfietzoglou.cc,v 1.8 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "G4FinalStateExcitationEmfietzoglou.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationMillerGreen.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationMillerGreen.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationMillerGreen.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateExcitationMillerGreen.cc,v 1.6 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "G4FinalStateExcitationMillerGreen.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationBorn.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationBorn.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationBorn.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateIonisationBorn.cc,v 1.19 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "G4FinalStateIonisationBorn.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationRudd.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationRudd.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationRudd.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStateIonisationRudd.cc,v 1.11 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #include "G4FinalStateIonisationRudd.hh"
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateKill.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateKill.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateKill.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FinalStateKill.cc,v 1.1 2007/11/09 20:26:12 pia Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateProduct.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateProduct.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateProduct.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FinalStateProduct.cc,v 1.7 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStatePsCreationChampion.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStatePsCreationChampion.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStatePsCreationChampion.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4FinalStatePsCreationChampion.cc,v 1.2 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // -------------------------------------------------------------------
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FluoTransition.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FluoTransition.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FluoTransition.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FluoTransition.cc,v 1.2 ????
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Elena Guardincerri (Elena.Guardincerri@ge.infn.it)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4IonParametrisedLossModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4IonParametrisedLossModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4IonParametrisedLossModel.cc	(revision 1228)
@@ -56,4 +56,12 @@
 //                             - Minor fix in ComputeLossForStep function  
 //                             - Minor fix in ComputeDEDXPerVolume (AL)
+//                23. 11. 2009 - Changed energy loss limit from 0.15 to 0.01
+//                               to improve accuracy for large steps (AL)
+//                24. 11. 2009 - Bug fix: Range calculation corrected if same 
+//                               materials appears with different cuts in diff.
+//                               regions (added UpdateRangeCache function and
+//                               modified BuildRangeVector, ComputeLossForStep
+//                               functions accordingly, added new cache param.)
+//                             - Removed GetRange function (AL)  
 //
 //
@@ -102,5 +110,5 @@
     corrections(0),
     corrFactor(1.0),
-    energyLossLimit(0.15),
+    energyLossLimit(0.01),
     cutEnergies(0) {
 
@@ -124,5 +132,5 @@
   upperEnergyEdgeIntegr = betheBlochModel -> HighEnergyLimit();
 
-  // Cached parameters are reset
+  // Cache parameters are set
   cacheParticle = 0;
   cacheMass = 0;
@@ -130,5 +138,11 @@
   cacheChargeSquare = 0;
 
-  // Cached parameters are reset
+  // Cache parameters are set
+  rangeCacheParticle = 0; 
+  rangeCacheMatCutsCouple = 0; 
+  rangeCacheEnergyRange = 0; 
+  rangeCacheRangeEnergy = 0;
+
+  // Cache parameters are set
   dedxCacheParticle = 0;
   dedxCacheMaterial = 0;
@@ -192,4 +206,10 @@
   cacheChargeSquare = 0;
   
+  // Cached parameters are reset
+  rangeCacheParticle = 0; 
+  rangeCacheMatCutsCouple = 0; 
+  rangeCacheEnergyRange = 0; 
+  rangeCacheRangeEnergy = 0;
+
   // Cached parameters are reset
   dedxCacheParticle = 0;
@@ -723,4 +743,43 @@
 // #########################################################################
 
+void G4IonParametrisedLossModel::UpdateRangeCache(
+                     const G4ParticleDefinition* particle,
+                     const G4MaterialCutsCouple* matCutsCouple) {
+
+  // ############## Caching ##################################################
+  // If the ion-material-cut combination is covered by any native ion data
+  // parameterisation (for low energies), range vectors are computed 
+
+  if(particle == rangeCacheParticle && 
+     matCutsCouple == rangeCacheMatCutsCouple) {
+  }
+  else{
+     rangeCacheParticle = particle;
+     rangeCacheMatCutsCouple = matCutsCouple;
+
+     const G4Material* material = matCutsCouple -> GetMaterial();
+     LossTableList::iterator iter = IsApplicable(particle, material);
+
+     // If any table is applicable, the transition factor is computed:
+     if(iter != lossTableList.end()) {
+
+        // Build range-energy and energy-range vectors if they don't exist
+        IonMatCouple ionMatCouple = std::make_pair(particle, matCutsCouple);
+        RangeEnergyTable::iterator iterRange = r.find(ionMatCouple);
+
+        if(iterRange == r.end()) BuildRangeVector(particle, matCutsCouple);
+
+        rangeCacheEnergyRange = E[ionMatCouple];    
+        rangeCacheRangeEnergy = r[ionMatCouple];
+     }
+     else {
+        rangeCacheEnergyRange = 0;    
+        rangeCacheRangeEnergy = 0;
+     }
+  }
+}
+
+// #########################################################################
+
 void G4IonParametrisedLossModel::UpdateDEDXCache(
                      const G4ParticleDefinition* particle,
@@ -793,14 +852,4 @@
                   	 (dEdxParam - dEdxBetheBloch)/dEdxBetheBloch
                              * transitionEnergy; 
-
-        // Build range-energy and energy-range vectors if they don't exist
-        IonMatCouple ionMatCouple = std::make_pair(particle, material);
-        RangeEnergyTable::iterator iterRange = r.find(ionMatCouple);
-
-        if(iterRange == r.end()) BuildRangeVector(particle, material, 
-                                                  cutEnergy);
-
-        dedxCacheEnergyRange = E[ionMatCouple];    
-        dedxCacheRangeEnergy = r[ionMatCouple];
      }
      else {
@@ -815,6 +864,4 @@
         dedxCacheTransitionEnergy = 0.0;
         dedxCacheTransitionFactor = 0.0;
-        dedxCacheEnergyRange = 0;    
-        dedxCacheRangeEnergy = 0;
      }
   }
@@ -899,6 +946,6 @@
      if(eloss > energyLossLimit * kineticEnergy) {
 
-        eloss = ComputeLossForStep(material, particle, 
-                                   kineticEnergy, cutEnergy,length);
+        eloss = ComputeLossForStep(couple, particle, 
+                                   kineticEnergy,length);
 
 #ifdef PRINT_DEBUG
@@ -972,6 +1019,11 @@
 void G4IonParametrisedLossModel::BuildRangeVector(
                      const G4ParticleDefinition* particle,
-                     const G4Material* material,
-                     G4double cutEnergy) {
+                     const G4MaterialCutsCouple* matCutsCouple) {
+
+  G4double cutEnergy = DBL_MAX;
+  size_t cutIndex = matCutsCouple -> GetIndex();
+  cutEnergy = cutEnergies[cutIndex];
+
+  const G4Material* material = matCutsCouple -> GetMaterial();
 
   G4double massRatio = genericIonPDGMass / particle -> GetPDGMass();
@@ -1077,5 +1129,5 @@
 #endif 
 
-  IonMatCouple ionMatCouple = std::make_pair(particle, material); 
+  IonMatCouple ionMatCouple = std::make_pair(particle, matCutsCouple); 
 
   E[ionMatCouple] = energyRangeVector;
@@ -1085,65 +1137,16 @@
 // #########################################################################
 
-G4double G4IonParametrisedLossModel::GetRange(
-                  const G4ParticleDefinition* particle, // Projectile
-		  const G4Material* material,           // Target Material
-	          G4double kineticEnergy) {
-
-  G4double range = 0.0;
-
-  IonMatCouple couple = std::make_pair(particle, material);
-
-  EnergyRangeTable::iterator iter = E.find(couple);
-
-  if(iter == E.end()) {
-     G4cerr << "G4IonParametrisedLossModel::GetRange() No range vector found."
-            << G4endl;
-
-     G4cout << "   Ion-material pair: " << particle ->GetParticleName()
-            << "  " << material -> GetName()
-            << G4endl
-            << "   Available couples:"
-            << G4endl;
-
-     EnergyRangeTable::iterator iter_beg = E.begin();
-     EnergyRangeTable::iterator iter_end = E.end();
-
-     for(;iter_beg != iter_end; iter_beg++) {
-         IonMatCouple key = (*iter_beg).first; 
- 
-         G4cout << "           " << (key.first) -> GetParticleName()
-                << "  " << (key.second) -> GetName()
-                << G4endl;
-     }
-  }
-  else {
-     G4PhysicsVector* energyRange = (*iter).second;
-
-     if(energyRange != 0) {
-        G4bool b;
-
-        // Computing range for kinetic energy:
-        range = energyRange -> GetValue(kineticEnergy, b);
-     }
-  }
-
-  return range;
-}
-
-// #########################################################################
-
 G4double G4IonParametrisedLossModel::ComputeLossForStep(
-                     const G4Material* material,
+                     const G4MaterialCutsCouple* matCutsCouple,
                      const G4ParticleDefinition* particle,
                      G4double kineticEnergy,
-                     G4double cutEnergy,
                      G4double stepLength) {
 
   G4double loss = 0.0;
 
-  UpdateDEDXCache(particle, material, cutEnergy);
-
-  G4PhysicsVector* energyRange = dedxCacheEnergyRange;
-  G4PhysicsVector* rangeEnergy = dedxCacheRangeEnergy;
+  UpdateRangeCache(particle, matCutsCouple);
+
+  G4PhysicsVector* energyRange = rangeCacheEnergyRange;
+  G4PhysicsVector* rangeEnergy = rangeCacheRangeEnergy;
 
   if(energyRange != 0 && rangeEnergy != 0) {
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LinInterpolation.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LinInterpolation.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LinInterpolation.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LinInterpolation.cc,v 1.5 2009/09/25 07:41:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreBremsstrahlungModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreBremsstrahlungModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreBremsstrahlungModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreBremsstrahlungModel.cc,v 1.6 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreComptonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreComptonModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreComptonModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreComptonModel.cc,v 1.7 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreGammaConversionModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreGammaConversionModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreGammaConversionModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreGammaConversionModel.cc,v 1.8 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreIonisationModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreIonisationModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreIonisationModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreIonisationModel.cc,v 1.7 2009/10/23 09:30:08 pandola Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePhotoElectricModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePhotoElectricModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePhotoElectricModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermorePhotoElectricModel.cc,v 1.9 2009/10/23 09:31:03 pandola Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedComptonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedComptonModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedComptonModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermorePolarizedComptonModel.cc,v 1.6 2009/05/03 08:29:55 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // History:
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedRayleighModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedRayleighModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermorePolarizedRayleighModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermorePolarizedRayleighModel.cc,v 1.5 2009/05/02 15:20:53 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // History:
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreRayleighModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreRayleighModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LivermoreRayleighModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LivermoreRayleighModel.cc,v 1.8 2009/09/23 16:54:06 flongo Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Sebastien Inserti
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LogLogInterpolation.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LogLogInterpolation.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LogLogInterpolation.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LogLogInterpolation.cc,v 1.16 2009/09/25 07:41:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyBremsstrahlung.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyBremsstrahlung.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyBremsstrahlung.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LowEnergyBremsstrahlung.cc,v 1.74 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // --------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyCompton.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyCompton.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyCompton.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LowEnergyCompton.cc,v 1.50 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: A. Forti
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyGammaConversion.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyGammaConversion.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyGammaConversion.cc	(revision 1228)
@@ -27,5 +27,5 @@
 ///
 // $Id: G4LowEnergyGammaConversion.cc,v 1.39 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyIonisation.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyIonisation.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyIonisation.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LowEnergyIonisation.cc,v 1.106 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // --------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyPhotoElectric.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyPhotoElectric.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyPhotoElectric.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LowEnergyPhotoElectric.cc,v 1.59 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: A. Forti
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyPolarizedCompton.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyPolarizedCompton.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyPolarizedCompton.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LowEnergyPolarizedCompton.cc,v 1.28 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // ------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyPolarizedRayleigh.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyPolarizedRayleigh.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyPolarizedRayleigh.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4LowEnergyPolarizedRayleigh.cc,v 1.10 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyRayleigh.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyRayleigh.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4LowEnergyRayleigh.cc	(revision 1228)
@@ -27,5 +27,5 @@
 //
 // $Id: G4LowEnergyRayleigh.cc,v 1.40 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: A. Forti
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PaulKCrossSection.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PaulKCrossSection.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PaulKCrossSection.cc	(revision 1228)
@@ -25,17 +25,4 @@
 //
 //
-// History:
-// -----------
-//  21 Apr 2008   H. Abdelohauwed - 1st implementation
-//  29 Apr 2009   ALF  Major Design Revision
-//  11 Nov 2009   ALF update and code cleaning for the Dec Release 
-//
-// -------------------------------------------------------------------
-
-// Class description:
-// Low Energy Electromagnetic Physics, Cross section, p ionisation, K shell
-// Further documentation available from http://www.ge.infn.it/geant4/lowE
-
-// -------------------------------------------------------------------
 
 #include "globals.hh"
@@ -43,84 +30,45 @@
 #include <fstream>
 #include <iomanip>
-//#include "G4CompositeEMDataSet.hh"
-//#include "G4ShellEMDataSet.hh"
+#include "G4CompositeEMDataSet.hh"
+#include "G4ShellEMDataSet.hh"
 #include "G4EMDataSet.hh"
-//#include "G4VEMDataSet.hh"
-//#include "G4VDataSetAlgorithm.hh"
+#include "G4VEMDataSet.hh"
+#include "G4VDataSetAlgorithm.hh"
 #include "G4LogLogInterpolation.hh"
 #include "G4PaulKCrossSection.hh"
-#include "G4Proton.hh"
-#include "G4Alpha.hh"
-
 
 G4PaulKCrossSection::G4PaulKCrossSection()
-{ 
+{ }
+
+G4PaulKCrossSection::~G4PaulKCrossSection()
+{ }
+
+G4double G4PaulKCrossSection::CalculateKCrossSection(G4int zTarget,G4int zIncident, G4double energyIncident)
+{
+  
+ G4String fileName;
+
+ if (zIncident == 1)
+   { fileName = "kcsPaul/kcs-";} 
+  else
+    {
+      if (zIncident == 2)
+	{ fileName = "kacsPaul/kacs-";}
+	
+    }
 
   
-  interpolation = new G4LogLogInterpolation();
+  G4VDataSetAlgorithm* interpolation = new G4LogLogInterpolation();
 
-  /*
-    G4String path = getenv("G4LEDATA");
- 
-    if (!path)
-    G4Exception("G4paulKCrossSection::G4paulKCrossSection: G4LEDATA environment variable not set");
-    G4cout << path + "/kcsPaul/kcs-" << G4endl;
-  */
+  G4VEMDataSet* dataSet;
 
+  dataSet = new G4EMDataSet(zTarget,interpolation);
+  
+  dataSet->LoadData(fileName);
+   
 
-    for (G4int i=4; i<93; i++) {
-      protonDataSetMap[i] = new G4EMDataSet(i,interpolation);
-      protonDataSetMap[i]->LoadData("pixe/kpcsPaul/kcs-");
-    }
-    for (G4int i=6; i<93; i++) {
-      alphaDataSetMap[i] = new G4EMDataSet(i,interpolation);
-      alphaDataSetMap[i]->LoadData("pixe/kacsPaul/kacs-");
-    }
+          G4double sigma = dataSet->FindValue(energyIncident/MeV) / barn;
 
-
-
-
-}
-
-G4PaulKCrossSection::~G4PaulKCrossSection()
-{ 
-
-  protonDataSetMap.clear();
-  alphaDataSetMap.clear();
-
-}
-
-G4double G4PaulKCrossSection::CalculateKCrossSection(G4int zTarget,G4double massIncident, G4double energyIncident)
-{
-  
-  G4Proton* aProtone = G4Proton::Proton();
-  G4Alpha* aAlpha = G4Alpha::Alpha();
-  
-  G4double sigma = 0;
-
-  if (massIncident == aProtone->GetPDGMass() )
-    {
-      
-      sigma = protonDataSetMap[zTarget]->FindValue(energyIncident/MeV) / barn; 
-      
-    }
-  else
-    {
-      if (massIncident == aAlpha->GetPDGMass())
-	{
-	  
-          sigma = alphaDataSetMap[zTarget]->FindValue(energyIncident/MeV) / barn; 
-	  
-	}
-      else
-	{ 
-	  G4cout << "we can treat only Proton or Alpha incident particles " << G4endl;
-	  sigma = 0.;
-	}
-    }
-  
-  
-  
-  return sigma;
+	  return sigma;
 }
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeAnnihilationModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeAnnihilationModel.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeAnnihilationModel.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeAnnihilationModel.cc,v 1.4 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Author: Luciano Pandola
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlung.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlung.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlung.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeBremsstrahlung.cc,v 1.21 2009/06/11 15:47:08 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // --------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungAngular.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungAngular.cc	(revision 1227)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeBremsstrahlungAngular.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PenelopeBremsstrahlungAngular.cc,v 1.8 2009/06/10 13:32:36 mantero Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 // 
 // --------------------------------------------------------------
